package anywheresoftware.b4a.samples.ticktacktoe;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	private static final boolean fullScreen = false;
	private static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "anywheresoftware.b4a.samples.ticktacktoe", "main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                anywheresoftware.b4a.keywords.Common.Log("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
		activityBA = new BA(this, layout, processBA, "anywheresoftware.b4a.samples.ticktacktoe", "main");
        processBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        initializeProcessGlobals();		
        initializeGlobals();
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (mostCurrent == null || mostCurrent != this)
			return;
        processBA.setActivityPaused(false);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
		return true;
	}
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyDown(keyCode, event);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            anywheresoftware.b4a.keywords.Common.Log("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static String[][] _buttonstext = null;
public static String _currentplayer = "";
public anywheresoftware.b4a.objects.ButtonWrapper[][] _buttons = null;
public anywheresoftware.b4a.objects.LabelWrapper _lblplayer = null;
public kalenderactivity _kalenderactivity = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
int _width = 0;
int _offsetx = 0;
int _offsety = 0;
int _x = 0;
int _y = 0;
anywheresoftware.b4a.objects.ButtonWrapper _b = null;
 //BA.debugLineNum = 12;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 14;BA.debugLine="Dim width, offsetX, offsetY As Int";
_width = 0;
_offsetx = 0;
_offsety = 0;
 //BA.debugLineNum = 15;BA.debugLine="width = 80dip";
_width = anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(80));
 //BA.debugLineNum = 16;BA.debugLine="offsetX = (100%x - width * 3 - 10dip * 2) / 2";
_offsetx = (int)((anywheresoftware.b4a.keywords.Common.PerXToCurrent((float)(100),mostCurrent.activityBA)-_width*3-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))*2)/(double)2);
 //BA.debugLineNum = 17;BA.debugLine="offsetY = (100%y - width * 3 - 10dip * 2) / 2";
_offsety = (int)((anywheresoftware.b4a.keywords.Common.PerYToCurrent((float)(100),mostCurrent.activityBA)-_width*3-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10))*2)/(double)2);
 //BA.debugLineNum = 18;BA.debugLine="For x = 0 To 2";
{
final double step14 = 1;
final double limit14 = (int)(2);
for (_x = (int)(0); (step14 > 0 && _x <= limit14) || (step14 < 0 && _x >= limit14); _x += step14) {
 //BA.debugLineNum = 19;BA.debugLine="For y = 0 To 2";
{
final double step15 = 1;
final double limit15 = (int)(2);
for (_y = (int)(0); (step15 > 0 && _y <= limit15) || (step15 < 0 && _y >= limit15); _y += step15) {
 //BA.debugLineNum = 20;BA.debugLine="Dim b As Button";
_b = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 21;BA.debugLine="b.Initialize(\"button\") 'All buttons share the same event sub";
_b.Initialize(mostCurrent.activityBA,"button");
 //BA.debugLineNum = 22;BA.debugLine="b.TextSize = 30";
_b.setTextSize((float)(30));
 //BA.debugLineNum = 23;BA.debugLine="Activity.AddView(b,offsetX + x * (width + 10dip), offsetY + y * (width + 10dip), width, width)";
mostCurrent._activity.AddView((android.view.View)(_b.getObject()),(int)(_offsetx+_x*(_width+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)))),(int)(_offsety+_y*(_width+anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)))),_width,_width);
 //BA.debugLineNum = 24;BA.debugLine="Buttons(x, y) = b 'store a reference to this view";
mostCurrent._buttons[_x][_y] = _b;
 }
};
 }
};
 //BA.debugLineNum = 28;BA.debugLine="lblPlayer.Initialize(\"\") 'views added programmatically should be initialized and added to the activity.";
mostCurrent._lblplayer.Initialize(mostCurrent.activityBA,"");
 //BA.debugLineNum = 29;BA.debugLine="lblPlayer.TextSize = 20";
mostCurrent._lblplayer.setTextSize((float)(20));
 //BA.debugLineNum = 30;BA.debugLine="lblPlayer.TextColor = Colors.White";
mostCurrent._lblplayer.setTextColor(anywheresoftware.b4a.keywords.Common.Colors.White);
 //BA.debugLineNum = 31;BA.debugLine="If GetDeviceLayoutValues.Height > GetDeviceLayoutValues.Width Then";
if (anywheresoftware.b4a.keywords.Common.GetDeviceLayoutValues(mostCurrent.activityBA).Height>anywheresoftware.b4a.keywords.Common.GetDeviceLayoutValues(mostCurrent.activityBA).Width) { 
 //BA.debugLineNum = 33;BA.debugLine="Activity.AddView(lblPlayer, 20dip, 10dip, 200dip, 40dip)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lblplayer.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(20)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(40)));
 }else {
 //BA.debugLineNum = 36;BA.debugLine="Activity.AddView(lblPlayer, 2dip, 10dip, offsetX - 15dip, 200dip)";
mostCurrent._activity.AddView((android.view.View)(mostCurrent._lblplayer.getObject()),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(2)),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(10)),(int)(_offsetx-anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(15))),anywheresoftware.b4a.keywords.Common.DipToCurrent((int)(200)));
 };
 //BA.debugLineNum = 38;BA.debugLine="UpdateCurrentPlayer";
_updatecurrentplayer();
 //BA.debugLineNum = 40;BA.debugLine="Activity.AddMenuItem(\"New Game\", \"mnuNewGame\")";
mostCurrent._activity.AddMenuItem("New Game","mnuNewGame");
 //BA.debugLineNum = 41;BA.debugLine="Activity.AddMenuItem(\"Kalender\", \"mnuKalender\")";
mostCurrent._activity.AddMenuItem("Kalender","mnuKalender");
 //BA.debugLineNum = 42;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
int _x = 0;
int _y = 0;
 //BA.debugLineNum = 51;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 52;BA.debugLine="If UserClosed Then";
if (_userclosed) { 
 //BA.debugLineNum = 54;BA.debugLine="NewGame";
_newgame();
 };
 //BA.debugLineNum = 57;BA.debugLine="For x = 0 To 2";
{
final double step46 = 1;
final double limit46 = (int)(2);
for (_x = (int)(0); (step46 > 0 && _x <= limit46) || (step46 < 0 && _x >= limit46); _x += step46) {
 //BA.debugLineNum = 58;BA.debugLine="For y = 0 To 2";
{
final double step47 = 1;
final double limit47 = (int)(2);
for (_y = (int)(0); (step47 > 0 && _y <= limit47) || (step47 < 0 && _y >= limit47); _y += step47) {
 //BA.debugLineNum = 59;BA.debugLine="ButtonsText(x, y) = Buttons(x, y).Text";
_buttonstext[_x][_y] = mostCurrent._buttons[_x][_y].getText();
 }
};
 }
};
 //BA.debugLineNum = 62;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
int _x = 0;
int _y = 0;
 //BA.debugLineNum = 43;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 45;BA.debugLine="For x = 0 To 2";
{
final double step36 = 1;
final double limit36 = (int)(2);
for (_x = (int)(0); (step36 > 0 && _x <= limit36) || (step36 < 0 && _x >= limit36); _x += step36) {
 //BA.debugLineNum = 46;BA.debugLine="For y = 0 To 2";
{
final double step37 = 1;
final double limit37 = (int)(2);
for (_y = (int)(0); (step37 > 0 && _y <= limit37) || (step37 < 0 && _y >= limit37); _y += step37) {
 //BA.debugLineNum = 47;BA.debugLine="Buttons(x, y).Text = ButtonsText(x, y)";
mostCurrent._buttons[_x][_y].setText((Object)(_buttonstext[_x][_y]));
 }
};
 }
};
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
public static String  _button_click() throws Exception{
anywheresoftware.b4a.objects.ButtonWrapper _b = null;
boolean _freecellleft = false;
int _x = 0;
int _y = 0;
 //BA.debugLineNum = 85;BA.debugLine="Sub Button_Click";
 //BA.debugLineNum = 87;BA.debugLine="Dim b As Button";
_b = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 88;BA.debugLine="b = Sender";
_b.setObject((android.widget.Button)(anywheresoftware.b4a.keywords.Common.Sender(mostCurrent.activityBA)));
 //BA.debugLineNum = 89;BA.debugLine="If b.Text <> \"\" Then Return 'Already used button";
if ((_b.getText()).equals("") == false) { 
if (true) return "";};
 //BA.debugLineNum = 90;BA.debugLine="b.Text = CurrentPlayer";
_b.setText((Object)(_currentplayer));
 //BA.debugLineNum = 91;BA.debugLine="If CheckIfWin(CurrentPlayer) Then";
if (_checkifwin(_currentplayer)) { 
 //BA.debugLineNum = 93;BA.debugLine="Msgbox(\"The winner is: \" & CurrentPlayer, \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("The winner is: "+_currentplayer,"",mostCurrent.activityBA);
 //BA.debugLineNum = 94;BA.debugLine="NewGame";
_newgame();
 //BA.debugLineNum = 95;BA.debugLine="Return";
if (true) return "";
 };
 //BA.debugLineNum = 98;BA.debugLine="If CurrentPlayer = \"X\" Then CurrentPlayer = \"O\" Else CurrentPlayer = \"X\"";
if ((_currentplayer).equals("X")) { 
_currentplayer = "O";}
else {
_currentplayer = "X";};
 //BA.debugLineNum = 99;BA.debugLine="UpdateCurrentPlayer";
_updatecurrentplayer();
 //BA.debugLineNum = 102;BA.debugLine="Dim freeCellLeft As Boolean";
_freecellleft = false;
 //BA.debugLineNum = 103;BA.debugLine="freeCellLeft = False";
_freecellleft = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 104;BA.debugLine="For x = 0 To 2";
{
final double step84 = 1;
final double limit84 = (int)(2);
for (_x = (int)(0); (step84 > 0 && _x <= limit84) || (step84 < 0 && _x >= limit84); _x += step84) {
 //BA.debugLineNum = 105;BA.debugLine="For y = 0 To 2";
{
final double step85 = 1;
final double limit85 = (int)(2);
for (_y = (int)(0); (step85 > 0 && _y <= limit85) || (step85 < 0 && _y >= limit85); _y += step85) {
 //BA.debugLineNum = 106;BA.debugLine="freeCellLeft = freeCellLeft OR Buttons(x, y).Text = \"\"";
_freecellleft = _freecellleft || (mostCurrent._buttons[_x][_y].getText()).equals("");
 }
};
 }
};
 //BA.debugLineNum = 109;BA.debugLine="If freeCellLeft = False Then";
if (_freecellleft==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 110;BA.debugLine="Msgbox(\"Both lost!\", \"\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Both lost!","",mostCurrent.activityBA);
 //BA.debugLineNum = 111;BA.debugLine="NewGame";
_newgame();
 };
 //BA.debugLineNum = 113;BA.debugLine="End Sub";
return "";
}
public static boolean  _checkifwin(String _player) throws Exception{
boolean _found = false;
int _x = 0;
int _y = 0;
int _i = 0;
 //BA.debugLineNum = 114;BA.debugLine="Sub CheckIfWin (Player As String) As Boolean";
 //BA.debugLineNum = 116;BA.debugLine="Dim found As Boolean";
_found = false;
 //BA.debugLineNum = 117;BA.debugLine="For x = 0 To 2";
{
final double step96 = 1;
final double limit96 = (int)(2);
for (_x = (int)(0); (step96 > 0 && _x <= limit96) || (step96 < 0 && _x >= limit96); _x += step96) {
 //BA.debugLineNum = 118;BA.debugLine="found = True";
_found = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 119;BA.debugLine="For y = 0 To 2";
{
final double step98 = 1;
final double limit98 = (int)(2);
for (_y = (int)(0); (step98 > 0 && _y <= limit98) || (step98 < 0 && _y >= limit98); _y += step98) {
 //BA.debugLineNum = 120;BA.debugLine="found = found AND Buttons(x, y).Text = Player";
_found = _found && (mostCurrent._buttons[_x][_y].getText()).equals(_player);
 }
};
 //BA.debugLineNum = 122;BA.debugLine="If found = True Then Return True";
if (_found==anywheresoftware.b4a.keywords.Common.True) { 
if (true) return anywheresoftware.b4a.keywords.Common.True;};
 }
};
 //BA.debugLineNum = 125;BA.debugLine="For y = 0 To 2";
{
final double step103 = 1;
final double limit103 = (int)(2);
for (_y = (int)(0); (step103 > 0 && _y <= limit103) || (step103 < 0 && _y >= limit103); _y += step103) {
 //BA.debugLineNum = 126;BA.debugLine="found = True";
_found = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 127;BA.debugLine="For x = 0 To 2";
{
final double step105 = 1;
final double limit105 = (int)(2);
for (_x = (int)(0); (step105 > 0 && _x <= limit105) || (step105 < 0 && _x >= limit105); _x += step105) {
 //BA.debugLineNum = 128;BA.debugLine="found = found AND Buttons(x, y).Text = Player";
_found = _found && (mostCurrent._buttons[_x][_y].getText()).equals(_player);
 }
};
 //BA.debugLineNum = 130;BA.debugLine="If found = True Then Return True";
if (_found==anywheresoftware.b4a.keywords.Common.True) { 
if (true) return anywheresoftware.b4a.keywords.Common.True;};
 }
};
 //BA.debugLineNum = 133;BA.debugLine="found = True";
_found = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 134;BA.debugLine="For i = 0 To 2";
{
final double step111 = 1;
final double limit111 = (int)(2);
for (_i = (int)(0); (step111 > 0 && _i <= limit111) || (step111 < 0 && _i >= limit111); _i += step111) {
 //BA.debugLineNum = 135;BA.debugLine="found = found AND Buttons(i, i).Text = Player";
_found = _found && (mostCurrent._buttons[_i][_i].getText()).equals(_player);
 }
};
 //BA.debugLineNum = 137;BA.debugLine="If found = True Then Return True";
if (_found==anywheresoftware.b4a.keywords.Common.True) { 
if (true) return anywheresoftware.b4a.keywords.Common.True;};
 //BA.debugLineNum = 139;BA.debugLine="found = True";
_found = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 140;BA.debugLine="For i = 0 To 2";
{
final double step116 = 1;
final double limit116 = (int)(2);
for (_i = (int)(0); (step116 > 0 && _i <= limit116) || (step116 < 0 && _i >= limit116); _i += step116) {
 //BA.debugLineNum = 141;BA.debugLine="found = found AND Buttons(i, 2 - i).Text = Player";
_found = _found && (mostCurrent._buttons[_i][(int)(2-_i)].getText()).equals(_player);
 }
};
 //BA.debugLineNum = 143;BA.debugLine="If found = True Then Return True";
if (_found==anywheresoftware.b4a.keywords.Common.True) { 
if (true) return anywheresoftware.b4a.keywords.Common.True;};
 //BA.debugLineNum = 144;BA.debugLine="Return False";
if (true) return anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 145;BA.debugLine="End Sub";
return false;
}

public static void initializeProcessGlobals() {
    if (processGlobalsRun == false) {
	    processGlobalsRun = true;
		try {
                
		        main._process_globals();
kalenderactivity._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 7;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 8;BA.debugLine="Dim Buttons(3, 3) As Button";
mostCurrent._buttons = new anywheresoftware.b4a.objects.ButtonWrapper[(int)(3)][];
{
int d0 = mostCurrent._buttons.length;
int d1 = (int)(3);
for (int i0 = 0;i0 < d0;i0++) {
mostCurrent._buttons[i0] = new anywheresoftware.b4a.objects.ButtonWrapper[d1];
for (int i1 = 0;i1 < d1;i1++) {
mostCurrent._buttons[i0][i1] = new anywheresoftware.b4a.objects.ButtonWrapper();
}
}
}
;
 //BA.debugLineNum = 9;BA.debugLine="Dim lblPlayer As Label";
mostCurrent._lblplayer = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 10;BA.debugLine="End Sub";
return "";
}
public static String  _mnukalender_click() throws Exception{
 //BA.debugLineNum = 68;BA.debugLine="Sub mnuKalender_Click";
 //BA.debugLineNum = 69;BA.debugLine="StartActivity(KalenderActivity)";
anywheresoftware.b4a.keywords.Common.StartActivity(mostCurrent.activityBA,(Object)(mostCurrent._kalenderactivity.getObject()));
 //BA.debugLineNum = 70;BA.debugLine="End Sub";
return "";
}
public static String  _mnunewgame_click() throws Exception{
 //BA.debugLineNum = 64;BA.debugLine="Sub mnuNewGame_Click";
 //BA.debugLineNum = 65;BA.debugLine="NewGame";
_newgame();
 //BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _newgame() throws Exception{
int _x = 0;
int _y = 0;
 //BA.debugLineNum = 72;BA.debugLine="Sub NewGame";
 //BA.debugLineNum = 73;BA.debugLine="For x = 0 To 2";
{
final double step59 = 1;
final double limit59 = (int)(2);
for (_x = (int)(0); (step59 > 0 && _x <= limit59) || (step59 < 0 && _x >= limit59); _x += step59) {
 //BA.debugLineNum = 74;BA.debugLine="For y = 0 To 2";
{
final double step60 = 1;
final double limit60 = (int)(2);
for (_y = (int)(0); (step60 > 0 && _y <= limit60) || (step60 < 0 && _y >= limit60); _y += step60) {
 //BA.debugLineNum = 75;BA.debugLine="Buttons(x, y).Text = \"\"";
mostCurrent._buttons[_x][_y].setText((Object)(""));
 }
};
 }
};
 //BA.debugLineNum = 78;BA.debugLine="CurrentPlayer = \"X\"";
_currentplayer = "X";
 //BA.debugLineNum = 79;BA.debugLine="UpdateCurrentPlayer";
_updatecurrentplayer();
 //BA.debugLineNum = 80;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 1;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 2;BA.debugLine="Dim ButtonsText(3, 3) As String";
_buttonstext = new String[(int)(3)][];
{
int d0 = _buttonstext.length;
int d1 = (int)(3);
for (int i0 = 0;i0 < d0;i0++) {
_buttonstext[i0] = new String[d1];
java.util.Arrays.fill(_buttonstext[i0],"");
}
}
;
 //BA.debugLineNum = 3;BA.debugLine="Dim CurrentPlayer As String";
_currentplayer = "";
 //BA.debugLineNum = 4;BA.debugLine="CurrentPlayer = \"X\"";
_currentplayer = "X";
 //BA.debugLineNum = 5;BA.debugLine="End Sub";
return "";
}
public static String  _updatecurrentplayer() throws Exception{
 //BA.debugLineNum = 82;BA.debugLine="Sub UpdateCurrentPlayer";
 //BA.debugLineNum = 83;BA.debugLine="lblPlayer.Text = \"Current player: \" & CurrentPlayer";
mostCurrent._lblplayer.setText((Object)("Current player: "+_currentplayer));
 //BA.debugLineNum = 84;BA.debugLine="End Sub";
return "";
}
}
